#include <stdio.h>
#include <stdint.h>

void dump(const char * name, void* plt)
{
	uint8_t* instr = (uint8_t*)plt;
	printf("%s: %p\n", name, plt);
//	for (int i=0;i<12;i++) printf(" %.2X", instr[i]);
//	printf("\n");
}

int main()
{
#define dump(x) dump(#x, (void*)x);
	dump(printf);
	dump(fopen);
	dump(ftell);
	dump(fread);
	dump(fwrite);
	dump(fclose);
}
