    ; tile value : bit 15 = flipy, bit 14 = flipx, bit 13 = priority value      ; 00603182
    ;              bit 10-12 = palette, 0-9=tile#
    mov ebx,[ng16bbgval]
    mov dl,ch
    inc dword[bg1drwng+ebx*4]
    and ecx,3FFh
    and edx,1Fh
    add ecx,[ngptrdat2]
    add cx,[taddnfy16x16]
    test dword[vrama+eax],8000h
    jz %%noflipy
    add cx,[taddfy16x16]
%%noflipy
    test dword[vrama+eax],4000h
    jz %%noflipx
    inc cx
%%noflipx
%%nexttile
    push ecx
    push edx
    mov edx,[{ngpalcon4b}+edx*4]
    {test4ba}
    jnz near %%docache
%%returnfromcache
    cmp byte[{tltype4b}+ecx],2
    je near %%done
    cmp byte[{tltype4b}+ecx],0
    je near %%parttile
    {preparet4ba}
    ; start drawing from ecx
    test dword[vrama+eax],8000h                                                 ; 0060320E
    jnz near %%flipyfull
    add ecx,[yposng]
    test dword[vrama+eax],4000h
    jnz near %%flipxfull
    mov ebx,[ecx]
    add ebx,edx
    mov [edi],ebx
    mov ebx,[ecx+4]
    add ebx,edx
    mov [edi+4],ebx
    jmp %%done
%%flipxfull
    mov ebx,[ecx+4]
    bswap ebx
    add ebx,edx
    mov [edi],ebx
    mov ebx,[ecx]
    bswap ebx
    add ebx,edx
    mov [edi+4],ebx
    jmp %%done
%%flipyfull
    add ecx,[flipyposng]
    test word[vrama+eax],4000h
    jnz near %%flipxyfull
    mov ebx,[ecx]
    add ebx,edx
    mov [edi],ebx
    mov ebx,[ecx+4]
    add ebx,edx
    mov [edi+4],ebx
    jmp %%done
%%flipxyfull
    mov ebx,[ecx+4]
    bswap ebx
    add ebx,edx
    mov [edi],ebx
    mov ebx,[ecx]
    bswap ebx
    add ebx,edx
    mov [edi+4],ebx
    jmp %%done
%%parttile
    {preparet4ba}
    ; start drawing from ecx to edi
    test word[vrama+eax],8000h                                                  ; 006032A9
    jnz near %%flipypart
    add ecx,[yposng]
    test word[vrama+eax],4000h
    jnz near %%flipxpart
    mov ebx,[ecx]
    or ebx,ebx
    jz %%drawd
    add ebx,edx
    test bl,{0Fh}
    jz %%drawa
    mov [edi],bl
%%drawa
    test bh,{0Fh}
    jz %%drawb
    mov [edi+1],bh
%%drawb
    shr ebx,16
    test bl,{0Fh}
    jz %%drawc
    mov [edi+2],bl
%%drawc
    test bh,{0Fh}
    jz %%drawd
    mov [edi+3],bh
%%drawd
    mov ebx,[ecx+4]
    or ebx,ebx
    jz %%drawd2
    add ebx,edx                                                                 ; 00603300
    test bl,{0Fh}
    jz %%drawa2
    mov [edi+4],bl
%%drawa2
    test bh,{0Fh}
    jz %%drawb2
    mov [edi+5],bh
%%drawb2
    shr ebx,16
    test bl,{0Fh}
    jz %%drawc2
    mov [edi+6],bl
%%drawc2
    test bh,{0Fh}
    jz %%drawd2
    mov [edi+7],bh
%%drawd2
    jmp %%done

%%flipxpart                                                                     ; 00603328
    mov ebx,[ecx]
    or ebx,ebx
    jz %%drawdf
    add ebx,edx
    test bl,{0Fh}
    jz %%drawaf
    mov [edi+7],bl
%%drawaf
    test bh,{0Fh}
    jz %%drawbf
    mov [edi+6],bh
%%drawbf
    shr ebx,16
    test bl,{0Fh}
    jz %%drawcf
    mov [edi+5],bl
%%drawcf
    test bh,{0Fh}
    jz %%drawdf
    mov [edi+4],bh
%%drawdf
    mov ebx,[ecx+4]
    or ebx,ebx
    jz %%drawd2f
    add ebx,edx
    test bl,{0Fh}
    jz %%drawa2f
    mov [edi+3],bl
%%drawa2f
    test bh,{0Fh}
    jz %%drawb2f
    mov [edi+2],bh
%%drawb2f
    shr ebx,16
    test bl,{0Fh}
    jz %%drawc2f
    mov [edi+1],bl
%%drawc2f
    test bh,{0Fh}
    jz %%drawd2f
    mov [edi],bh
%%drawd2f
    jmp %%done

%%flipypart                                                                     ; 00603383
    add ecx,[flipyposng]
    test word[vrama+eax],4000h
    jnz near %%flipxypart
    mov ebx,[ecx]
    or ebx,ebx
    jz %%drawdm
    add ebx,edx
    test bl,{0Fh}
    jz %%drawam
    mov [edi],bl                                                                ; 006033A5
%%drawam
    test bh,{0Fh}
    jz %%drawbm
    mov [edi+1],bh
%%drawbm
    shr ebx,16
    test bl,{0Fh}
    jz %%drawcm
    mov [edi+2],bl
%%drawcm
    test bh,{0Fh}
    jz %%drawdm
    mov [edi+3],bh
%%drawdm
    mov ebx,[ecx+4]
    or ebx,ebx
    jz %%drawd2m
    add ebx,edx
    test bl,{0Fh}
    jz %%drawa2m
    mov [edi+4],bl
%%drawa2m
    test bh,{0Fh}
    jz %%drawb2m
    mov [edi+5],bh
%%drawb2m
    shr ebx,16
    test bl,{0Fh}
    jz %%drawc2m
    mov [edi+6],bl
%%drawc2m
    test bh,{0Fh}
    jz %%drawd2m
    mov [edi+7],bh
%%drawd2m
    jmp %%done

%%flipxypart
    mov ebx,[ecx]
    or ebx,ebx
    jz %%drawdfm
    add ebx,edx
    test bl,{0Fh}
    jz %%drawafm
    mov [edi+7],bl
%%drawafm
    test bh,{0Fh}
    jz %%drawbfm
    mov [edi+6],bh
%%drawbfm
    shr ebx,16
    test bl,{0Fh}
    jz %%drawcfm
    mov [edi+5],bl
%%drawcfm
    test bh,{0Fh}
    jz %%drawdfm
    mov [edi+4],bh
%%drawdfm
    mov ebx,[ecx+4]
    or ebx,ebx
    jz %%drawd2fm
    add ebx,edx
    test bl,{0Fh}
    jz %%drawa2fm
    mov [edi+3],bl
%%drawa2fm
    test bh,{0Fh}
    jz %%drawb2fm
    mov [edi+2],bh
%%drawb2fm
    shr ebx,16
    test bl,{0Fh}
    jz %%drawc2fm
    mov [edi+1],bl
%%drawc2fm
    test bh,{0Fh}
    jz %%drawd2fm
    mov [edi],bh
%%drawd2fm
%%done
    pop edx
    pop ecx
    inc cx
    test dword[vrama+eax],4000h
    jz %%noflipxb
    sub cx,2
%%noflipxb
    add edi,8
    xor dword[switch16x16],1
    jnz near %%nexttile
%%ntile
    mov ebx,[ng16bbgval]
    add ax,2
    inc dword[bg1totng+ebx*4]
    test eax,03Fh
    jz %%tileadd
%%next
    dec byte[tleftn]
    jnz near {.loop}
    pop ebx
    cmp byte[curmosaicsz],1
    jne near domosaicng
    ret
{.finline}
    add edi,16
    jmp %%ntile
%%docache
    call {cachesingle4bng}                                                      ; 006034A2
    jmp %%returnfromcache
%%tileadd
    add ax,[bgtxadd]
    jmp %%next
